/*
 c-interface routines to enable use of the cmod tools from IDL
 Copyright (C) 2004   J. de Kloe (KNMI)
 License: GPL (see file COPYING)
*/

#include <stdio.h>
#include <string.h>

float c_interface(int argc, void *argv[])
{
    extern float calc_sigma0_cmod5_n_();  /* FORTRAN routine */

#define MAX_STRLEN 256

    typedef struct
      {
	unsigned int slen;
	unsigned int stype;
	char *s;
      } IDL_STRING;

    IDL_STRING *fortran_function_name_struct;
    char        fortran_function_name[MAX_STRLEN];
    float *v;
    float *phi;
    float *theta;
    int i;

    fortran_function_name_struct = (IDL_STRING *) argv[0];
    
    if (fortran_function_name_struct == NULL)
      {
	printf("PROBLEM: fortran_function_name_struct = NULL !!!\n");
	exit(1);
      }
    
    if (fortran_function_name_struct->slen >= MAX_STRLEN)
      {
	printf("PROBLEM: inside c_interface.c:\n");
	printf("ERROR: fortran_function_name too long ...\n");
	exit(1);
      }

    if (fortran_function_name_struct->slen <= 0)
      {
	printf("PROBLEM: inside c_interface.c:\n");
	printf("ERROR: fortran_function_name not given ...\n");
	exit(1);
      }
    
    /* copy the IDL string into a c-string */
    for (i=0;i<fortran_function_name_struct->slen;i++)
      {	fortran_function_name[i] = fortran_function_name_struct->s[i]; }
    fortran_function_name[fortran_function_name_struct->slen] = '\0';

    v      = (float *) argv[1];  /* Get input float */
    phi    = (float *) argv[2];  /* Get input float */
    theta  = (float *) argv[3];  /* Get input float */

    if (strncmp(fortran_function_name,"cmod5n",6) == 0)
      {
	printf("executing fortran function: cmod5n() ....\n");
	return calc_sigma0_cmod5_n_(v,phi,theta);
      }

    printf("ERROR: unknown fortran_function_name: %s\n",fortran_function_name);
    return -999.0; 
}
